/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.thread;

import com.google.inject.AbstractModule;
import com.google.inject.matcher.Matchers;

/**
 * Guice module to install scopes, annotations and method interceptors used to handle thread-local
 * object caches.
 * 
 * @author diewald
 */
public class MultiThreadingModule extends AbstractModule {

	/** {@inheritDoc} */
	@Override
	protected void configure() {
		ThreadScope scope = new ThreadScope();
		bindScope(ThreadScoped.class, scope);
		bind(ThreadScope.class).toInstance(scope);

		bindInterceptor(Matchers.any(), Matchers.annotatedWith(ThreadedMethod.class),
				new ThreadedMethodInterceptor(scope));
	}
}
