/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.feature.taskinstantiation.problem;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.decode.Decodes;
import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.decode.Genotyped;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.IExecutionUnitAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.ITaskAdapter;
import org.fortiss.af3.exploration.alg.dse.sysmodel.arch.taskgraph.AcyclicTaskGraph;
import org.fortiss.af3.exploration.alg.feature.taskinstantiation.variable.TaskInstanceEncoding;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.AcyclicTaskGraphEncoding;
import org.fortiss.af3.exploration.alg.feature.taskmapping.problem.TaskMappingToGraphDecoderBase;
import org.fortiss.af3.exploration.alg.feature.taskmapping.variable.TaskMappingEntry;
import org.opt4j.core.Genotype;
import org.opt4j.core.problem.Decoder;

import com.google.inject.Provides;

/**
 * {@link Decoder} that takes an {@link TaskInstanceEncoding} and {@link AcyclicTaskGraphEncoding}
 * as inputs and generates an {@link InstantiatedAcyclicTaskGraphEncoding} from it.
 * 
 * @author diewald
 */
public class TaskMappingToAcyclicGraphDecoder extends
		TaskMappingToGraphDecoderBase<AcyclicTaskGraph, InstantiatedAcyclicTaskGraphEncoding, IExecutionUnitAdapter, TaskMappingEntry<ITaskAdapter, IExecutionUnitAdapter>> {

	/** See {@link TaskMappingToAcyclicGraphDecoder}. */
	@Provides
	@Decodes
	public InstantiatedAcyclicTaskGraphEncoding decode(AcyclicTaskGraphEncoding atgEnc,
			@Genotyped TaskInstanceEncoding tInstEnc) {
		// TODO: Replace with "decode". Fixup type (generic) conversion.
		InstantiatedAcyclicTaskGraphEncoding iAtgEnc = new InstantiatedAcyclicTaskGraphEncoding(
				atgEnc.getTaskGraphs(), atgEnc.getHyperPeriod());

		instantiateTaskGraphs(iAtgEnc, tInstEnc);

		return iAtgEnc;
	}

	/** {@inheritDoc} */
	@Override
	public InstantiatedAcyclicTaskGraphEncoding decode(Genotype arg0) {
		// TODO Auto-generated method stub
		return null;
	}
}
