/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.module.common.evaluator;

/**
 * Implementation of {@code Value<Boolean>} that can represent itself as a Double by the
 * {@link #getDouble()} method. It returns zero if false and Double.MAX_VALUE if true.
 * 
 * @author diewald
 */
public class BooleanValue extends GenericValue<Boolean> {

	/** Constructor. */
	public BooleanValue(Boolean value) {
		super(value);
	}

	/** {@inheritDoc} */
	@Override
	public Double getDouble() {
		return getValue() ? Double.MAX_VALUE : 0D;
	}
}
