/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.service.module;

import org.fortiss.af3.exploration.alg.dse.backend.opt4j.d3seext.phenotype.Phenotype;
import org.opt4j.core.Genotype;

/**
 * Common operations for {@link Genotype}s and {@link Phenotype}s.
 * 
 * @author diewald
 */
// TODO: evaluate whether it would be better to let the geno- and phenotype inherit from an
// "Encoding".
public interface IExplorationEncoding {

	/** Marks an encoding as infeasible --> no need to continue processing this encoding. */
	void setInfeasible();

	/** Returns whether and encoding was marked as being infeasible. */
	boolean isInfeasible();
}
