/*-------------------------------------------------------------------------+
| Copyright 2016 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.exploration.alg.service.module.base;

import org.fortiss.af3.exploration.alg.service.module.IRepairModule;
import org.opt4j.core.Genotype;

/**
 * Base class for {@link IRepairModule}s.
 * 
 * @author diewald
 */
public abstract class RepairModuleBase<T extends Genotype> implements IRepairModule<T> {
	/** {@inheritDoc} */
	@Override
	public String getIntrospectionLabel() {
		return getClass().getSimpleName();
	}

	/** {@inheritDoc} */
	@Override
	public boolean showInIntrospectionNavigation() {
		// TODO Auto-generated method stub
		return false;
	}
}
